Subject: bug#44533: 27.1; Mac special key modifiers not functioning as expected

From: Andrii Kolomoiets <[email-masked]>
Date: Tue, 10 Nov 2020 11:55:23 +0200

[Please keep debbugs email in the recipient list on reply]

YH Tan <[email-masked]> writes:

> option+up/down/left/right doesn’t do anything on its own in the system. 
>
> In org-mode ‘C-h k’ just ignores the meta key and returns the arrow or
> RET key (in the case of org-insert-heading). Only things like ‘M-x’
> works with the reset right option in this case.

I can't reproduce this in GNU Emacs 27.1 (build 1,
x86_64-apple-darwin18.7.0, NS appkit-1671.60 Version 10.14.6 (Build
18G95)):

emacs -Q
M-: (setq mac-option-modifier 'nil)
M-: (setq mac-right-option-modifier 'meta)
Now 'C-h k' describes up/down/left/right keys alone when I press them
with the left option key and M-up/down/left/right keys when I press them
with the right option key.

>> On Nov 10, 2020, at 04:14, Andrii Kolomoiets <[email-masked]> wrote:
>> 
>> YH Tan <[email-masked]> writes:
>> 
>>> (setq mac-option-modifier 'nil)
>>> (setq mac-right-option-modifier 'meta)
>>> 
>>> the left option key is revived, but the right option key fails to capture
>>> some of the regular meta keybindings, such as org-do-promote/demote,
>>> org-move-subtree-up/down etc. 
>> 
>> Is it possible that those keybindings are handled by your OS?
>> 
>> For example, I'm using following settings:
>> 
>> (custom-set-variables
>> '(ns-command-modifier 'control)
>> '(ns-right-command-modifier 'super))
>> 
>> When I press Command-TAB, Emacs doesn't "see" C-TAB (or s-TAB) because
>> Command-TAB is used by OS to switch to another application.
>> 
>> Use 'C-h k' to see what key is pressed and what command it invokes.